#!/bin/csh
rm -f energies.dat
rm -f rumd_LJ.log
rm -f RelVar.dat
set steps = 100
set steps_ = 101


printf "test%d: rumd_LJ (pb,tp)=" $1
foreach pb (16 32)
  foreach tp (1 8)
    printf "(%s,%s);" $pb $tp 
    if ($1 == 0) then
      (../../../UserPrograms/rumd_LJ  --numIOBlocks=1 --IOBlockSize=${steps_} --pb=$pb --tp=$tp --Ti=0.500 --dt=0.005 --thermostat=1 --dump_nrg=${steps} > rumd_LJ${pb}_${tp}.log) >& rumd_LJ${pb}_${tp}.err
      if($status == 0) then
	zcat TrajectoryFiles/energies*.dat.gz > energies.dat
	octave -q check.m > test.out; cat test.out
      else
	goto fail
      endif
    endif 
    if ($1 == 1) then
      (../../../UserPrograms/rumd_LJ --numIOBlocks=1 --IOBlockSize=10000 --pb=$pb --tp=$tp --Ti=0.500 --dt=0.002 --thermostat=0 --dump_nrg=50 > rumd_LJ${pb}_${tp}.log) >& rumd_LJ${pb}_${tp}.err
	if($status == 0) then
	    zcat TrajectoryFiles/energies*.dat.gz > energies.dat
	    octave -q check_totalenergy.m > test.out; cat test.out
	    printf  "%s %s " $pb $tp >> RelVar.dat
	    tail -n 1 RelVar_.dat >> RelVar.dat
	else
	    goto fail
	endif
    endif
  end
end
done:
    echo ' DONE (No news is good news)' 
    exit 0
fail:
    echo 'Something failed in rumd_LJ; check .err file(s)'
    exit 1
