#ifndef MD_NEIGHBORLIST_H
#define MD_NEIGHBORLIST_H

/*
    Copyright (C) 2010  Thomas Schrøder

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    LICENSE.txt file for license details.
*/

#include "md_ParticleData.h"
#include "rumd_potentials.h"

class NeighborList {
  
public:
  NeighborList( int set_con );
   
  ~NeighborList();
  
  void Initialize( ParticleData* pData, dim3 set_grid, dim3 set_threads, size_t set_shared_size, int nb, int nvp);

  void Free();

  void SetCutoffs(Potential* potential, float skin);

  void UpdateNBlist(float* d_L, float* d_invL);
  
  void UpdateNBlistInit(float* d_L, float* d_invL);

  void PrintCellList();

  //protected:

  ParticleData* particleData;

  unsigned int numParticles;

  int numBlocks;
  int numBlocksParticles;
  int con;
	
  dim3 grid;
  
  dim3 threads;

  size_t shared_size;

  float*  d_shell2;
  int*    d_ctrl;

  NBTYPEv* NbList;
  int* cell_list;
};


#endif // MD_NEIGHBORLIST_H
