#ifndef MD_KERNEL_H
#define MD_KERNEL_H

/*
    Copyright (C) 2010  Thomas Schrøder

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    LICENSE.txt file for license details.
*/

#include "md_kernel_forces.h"

///////////////////////////////////////////////////////////////////////////
// This header defines global kernel implementations in the different files.
///////////////////////////////////////////////////////////////////////////

////////////////////// md_kernel_nblist.cu //////////////////////

// __device__ float calc_dist2( float4 my_r, float4 rj, float L, float invL );
__global__ void md_update_nblist0( unsigned int num_part, float4* r, float4* im, float* params, float* L, float* invL, NBTYPEv *NbList, int* cell_list, int* check );
__global__ void md_update_nblist( unsigned int num_part, float4* r, float4* im, float* params, float* L, float* invL, NBTYPEv *NbList, int* cell_list, int *check );
// __device__ void update_nblist( unsigned int num_part, float4 my_r, float4 *r, float* params, float L, float invL, NBTYPEv *NbList );

////////////////////// md_IntegratorNoseHoover.cu //////////////////////

__global__ void integrateNoseHooverAlgorithm( unsigned numParticles, float4* position, float4* velocity, float4* force, float4* image, 
					      float* boxL, float* invboxL, float* thermostatState, int* updateNbList, float timeStep, float nbListSkin );
__global__ void partialSummationKineticEnergy( unsigned int numParticles, float4* velocity, float* thermostatKineticEnergy );
__global__ void updateNoseHooverThermostatState( float* thermostatKineticEnergy, float* thermostatState, float thermostatMass, 
						 float targetTemperature, int degreesOfFreedom, float timeStep );
__global__ void partialSummationMomentum( unsigned int numParticles, float4* velocity, float4* particleMomentum );
__global__ void zeroTotalMomentum( unsigned int numParticles, float4* velocity, float4* particleMomentum );

//////////////////////////////////////////////////////////////////////
  
#endif // MD_KERNEL_H
